# diagradio.c File Reference

## Detailed Description

Implementation of the Radio Diagnostics Application.

Definition in file diagradio.c.

Go to the source code of this file.

## Defines
#define | NL "\n\r"
#define | TBLINK_PERIOD (500)
## Functions
time_t | blink (timer_arg_t t)
| Life LED timer service routine.
void | help (void)
| Print help for hotkeys.
int | main (void)
| Main function of diagradio application.
void | rdiag_init (void)
void | send_continous (void)
| Send frames permanently (next frame is triggered at TX_END_IRQ).
void | send_frame (uint8_t frmlen)
| Transmit a frame with a given payload length.
void | set_next_cca (void)
| Select CCA Mode.
void | set_next_channel (int8_t chaninc)
| Increment/decrement channel.
void | set_next_channel (channel_t chaninc)
void | set_next_pwr (int8_t pwrinc)
| Increment/decrement TX power.
void | show_statistic (bool reset)
| Display RX/TX transceiver statistic and state.
void | toggle_rxon_idle (void)
| Enable/disable mode RX_ON_IDL.
void | usr_radio_error (radio_error_t err)
| Callback for errors in radio module functions.
uint8_t * | usr_radio_receive_frame (uint8_t len, uint8_t *frm, uint8_t lqi, uint8_t rssi, uint8_t crc)
| Callback function for frame reception.
void | usr_radio_tx_done (radio_tx_done_t status)
| Callback function for TX_END IRQ.
## Variables
bool | conttx
static rdiag_ctx_t | RdiagCtx
statistic_t | RdiagStat
static uint8_t | RxBuf [MAX_FRAME_SIZE]
static rx_frame_t | rxfrm
timer_hdl_t | th_blink
trx_param_t PROGMEM | trxp_flash = {chan: 13, txp: 0, cca: 1, edt: 11, clkm: 0}
uint8_t | tx_length = 42
static uint8_t | TxBuf [MAX_FRAME_SIZE]
int8_t | verbose

## Function Documentation

time_t blink | ( | timer_arg_t | t | ) |

Life LED timer service routine.

Definition at line 592 of file diagradio.c.

void help | ( | void |  | ) |

Print help for hotkeys.

Definition at line 569 of file diagradio.c.

int main | ( | void |  | ) |

Main function of diagradio application.

This routine performs the initialization of the hardware modules and stays in a endless loop, which interpretes the commands, received from the host interface.

Definition at line 119 of file diagradio.c.

void send_continous | ( | void |  | ) |

Send frames permanently (next frame is triggered at TX_END_IRQ).

Definition at line 437 of file diagradio.c.

void send_frame | ( | uint8_t | seq | ) |

Transmit a frame with a given payload length.

Definition at line 406 of file diagradio.c.

void set_next_cca | ( | void |  | ) |

Select CCA Mode.

Definition at line 386 of file diagradio.c.

void set_next_channel | ( | int8_t | chaninc | ) |

Increment/decrement channel.

Definition at line 330 of file diagradio.c.

void set_next_pwr | ( | int8_t | pwrinc | ) |

Increment/decrement TX power.

Definition at line 366 of file diagradio.c.

void show_statistic | ( | bool | reset | ) |

Display RX/TX transceiver statistic and state.

Definition at line 506 of file diagradio.c.

void toggle_rxon_idle | ( | void |  | ) |

Enable/disable mode RX_ON_IDL.

Definition at line 349 of file diagradio.c.

void usr_radio_error | ( | radio_error_t | err | ) |

Callback for errors in radio module functions.

Definition at line 544 of file diagradio.c.

uint8_t* usr_radio_receive_frame | ( | uint8_t | len,
|  | uint8_t * | frm,
|  | uint8_t | lqi,
|  | uint8_t | rssi,
|  | uint8_t | crc |
| ) |  |  |

Callback function for frame reception.

Definition at line 466 of file diagradio.c.

void usr_radio_tx_done | ( | radio_tx_done_t | status | ) |

Callback function for TX_END IRQ.

Definition at line 489 of file diagradio.c.

## Variable Documentation

trx_param_t PROGMEM trxp_flash = {chan: 13, txp: 0, cca: 1, edt: 11, clkm: 0}

factory defaults of radio parameter

Definition at line 109 of file diagradio.c.